'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _babylon = require('babylon');

var _elementTree = require('./elementTree');

var Parser = (function () {
    function Parser() {
        _classCallCheck(this, Parser);

        this._strictModeEnabled = true;
    }

    _createClass(Parser, [{
        key: 'isStrictModeEnabled',
        value: function isStrictModeEnabled() {
            return this._strictModeEnabled;
        }
    }, {
        key: 'enableStrictMode',
        value: function enableStrictMode() {
            this._strictModeEnabled = true;
        }
    }, {
        key: 'disableStrictMode',
        value: function disableStrictMode() {
            this._strictModeEnabled = false;
        }
    }, {
        key: 'parse',
        value: function parse(code) {
            var ast = this._parseAst(code);
            var tokens = this._processTokens(ast, code);
            return (0, _elementTree.buildElementTree)(ast, tokens);
        }
    }, {
        key: '_parseAst',
        value: function _parseAst(code) {
            var opts = {
                sourceType: 'module',
                strictMode: this._strictModeEnabled,
                ecmaVersion: Infinity,
                allowHashBang: true,
                // generate with
                // $ node -p "Object.keys(require('babel-core/lib/transformation').pipeline.transformers)
                // .filter(/^$/.test.bind(/^es([7-9]|[0-9]{2,})./))
                // .sort().reduce(function(o, k) { o[k] = true; return o; }, {})"
                features: {
                    'es7.asyncFunctions': true,
                    'es7.classProperties': true,
                    'es7.comprehensions': true,
                    'es7.decorators': true,
                    'es7.doExpressions': true,
                    'es7.exponentiationOperator': true,
                    'es7.exportExtensions': true,
                    'es7.functionBind': true,
                    'es7.objectRestSpread': true,
                    'es7.trailingFunctionCommas': true
                },
                plugins: { jsx: true, flow: true }
            };
            var ast = (0, _babylon.parse)(code, opts);
            var program = ast.program;
            program.tokens = ast.tokens;
            return program;
        }
    }, {
        key: '_processTokens',
        value: function _processTokens(ast, code) {
            return (0, _elementTree.buildTokenList)(ast.tokens, code);
        }
    }]);

    return Parser;
})();

exports['default'] = Parser;
module.exports = exports['default'];